Index: trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1314)
+++ trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1321)
@@ -1649,109 +1498,1802 @@
   }
   // if we reach here, then the picture is not skipped.
-#if NH_MV
-  return !m_layerInitilizedFlag[ getLayerId() ]; 
+  return false;
+}
+
 #else
-  return false;
-#endif
-}
-#if NH_MV
-TComPic* TDecTop::getPic( Int poc )
-{
-  xGetPic( m_layerId, poc ); 
-  TComList<TComPic*>* listPic = getListPic();
-  TComPic* pcPic = NULL;
-  for(TComList<TComPic*>::iterator it=listPic->begin(); it!=listPic->end(); it++)
-  {
-    if( (*it)->getPOC() == poc )
-    {
-      pcPic = *it ;
-      break ;
-    }
-  }
-  return pcPic;
-}
-
-TComPic* TDecTop::xGetPic( Int layerId, Int poc )
+
+Int TDecTop::preDecodePoc( Bool firstPicInLayerDecodedFlag, Bool isFstPicOfAllLayOfPocResetPer, Bool isPocResettingPicture )
+{
+  //Output of this process is PicOrderCntVal, the picture order count of the current picture.
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  motion vector prediction and for decoder conformance checking (see clause F.13.5).
+
+  //  Each coded picture is associated with a picture order count variable, denoted as PicOrderCntVal.
+
+  TComSlice* slice = m_apcSlicePilot;
+  const Int nuhLayerId   = slice->getLayerId();
+  const TComVPS*   vps   = slice->getVPS(); 
+  const TComSPS*   sps   = slice->getSPS(); 
+
+  Int pocDecrementedInDpbFlag = m_pocDecrementedInDpbFlag[ nuhLayerId ]; 
+
+  if ( isFstPicOfAllLayOfPocResetPer )
+  {
+    //  When the current picture is the first picture among all layers of a POC resetting period, 
+    //  the variable PocDecrementedInDPBFlag[ i ] is set equal to 0 for each value of i in the range of 0 to 62, inclusive.
+    pocDecrementedInDpbFlag = false; 
+  }
+
+  //  The variable pocResettingFlag is derived as follows:
+  Bool pocResettingFlag; 
+  if ( isPocResettingPicture )
+  {
+    //-  If the current picture is a POC resetting picture, the following applies:    
+    if( vps->getVpsPocLsbAlignedFlag()  )
+    {
+      //  -  If vps_poc_lsb_aligned_flag is equal to 0, pocResettingFlag is set equal to 1.
+      pocResettingFlag = true; 
+    }
+    else if ( pocDecrementedInDpbFlag )
+    {
+      //  -  Otherwise, if PocDecrementedInDPBFlag[ nuh_layer_id ] is equal to 1, pocResettingFlag is set equal to 0.
+      pocResettingFlag = false; 
+    }
+    else
+    {
+      //  -  Otherwise, pocResettingFlag is set equal to 1.
+      pocResettingFlag = true; 
+    }
+  }
+  else
+  {
+    //  -  Otherwise, pocResettingFlag is set equal to 0.
+    pocResettingFlag = false; 
+  }
+
+  Int picOrderCntMsb; 
+  Int picOrderCntVal; 
+
+  //  Depending on pocResettingFlag, the following applies:
+  if ( pocResettingFlag )
+  {
+    //-  The PicOrderCntVal of the current picture is derived as follows:
+    if( slice->getPocResetIdc()  ==  1 )
+    {
+      picOrderCntVal = slice->getSlicePicOrderCntLsb(); 
+    }
+    else if (slice->getPocResetIdc()  ==  2 ) 
+    {
+      picOrderCntVal = 0; 
+    }
+    else
+    {
+      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() ); 
+      picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+    }
+  }
+  else
+  {
+    //-  Otherwise (pocResettingFlag is equal to 0), the following applies:
+    //-  The PicOrderCntVal of the current picture is derived as follows:
+
+    if( slice->getPocMsbCycleValPresentFlag() )
+    {
+      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb(); 
+    }
+    else if( !firstPicInLayerDecodedFlag  ||
+      slice->getNalUnitType()  ==  NAL_UNIT_CODED_SLICE_IDR_N_LP || slice->getNalUnitType() ==  NAL_UNIT_CODED_SLICE_IDR_W_RADL )
+    {
+      picOrderCntMsb = 0; //     (F 62)
+    }    
+    else
+    {
+      Int prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 );
+      Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
+      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
+    }
+    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+  }  
+  return picOrderCntVal;
+}
+
+Void TDecTop::inferPocResetPeriodId()
+{
+  // Infer PocResetPeriodId
+  // When not present, the value of poc_reset_period_id is inferred as follows:
+
+  if ( !m_apcSlicePilot->getHasPocResetPeriodIdPresent() )
+  {
+    if ( m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] != MIN_INT )
+    {
+      // - If the previous picture picA that has poc_reset_period_id present in the slice segment header is present in the same layer 
+      //   of the bitstream as the current picture, the value of poc_reset_period_id is inferred to be equal to the value of the 
+      //   poc_reset_period_id of picA.
+
+      m_apcSlicePilot->setPocResetPeriodId( m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] ); 
+    }
+    else
+    {
+      //- Otherwise, the value of poc_reset_period_id is inferred to be equal to 0.
+      m_apcSlicePilot->setPocResetPeriodId( 0 ); 
+    }
+  }
+  else
+  {
+    m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] = m_apcSlicePilot->getPocResetPeriodId();  
+  }
+}
+
+
+Void TDecTop::decodePocAndRps( )
 { 
-  return m_ivPicLists->getPic( layerId, poc ) ;
-}
-
-Void TDecTop::xResetPocInPicBuffer()
-{
-  TComList<TComPic*>::iterator  iterPic   = m_cListPic.begin();
-  while (iterPic != m_cListPic.end())
-  {
-    TComPic* pic = *(iterPic++);
-    if ( pic->getReconMark() )
-    {
-      for( Int i = 0; i < pic->getNumAllocatedSlice(); i++)
-      {
-        TComSlice* slice = pic->getSlice( i ); 
-        slice->setPOC ( slice->getPOC() - m_apcSlicePilot->getPocBeforeReset() );            
-      }         
-    }     
-  }
-}
-
-Void TDecTop::xCeckNoClrasOutput()
-{
-  // This part needs further testing! 
-  if ( getLayerId() == 0 )
+  assert( m_uiSliceIdx == 0 );
+  Int nuhLayerId = m_pcPic->getLayerId();
+  if ( m_decProcPocAndRps == CLAUSE_8 )
+  {
+    // 8.1.3 Decoding process for a coded picture with nuh_layer_id equal to 0
+
+    // Variables and functions relating to picture order count are derived as 
+    // specified in clause 8.3.1. This needs to be invoked only for the first slice 
+    // segment of a picture.
+    x831DecProcForPicOrderCount( );
+
+    // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference 
+    // pictures may be marked as "unused for reference" or "used for long-term 
+    // reference". This needs to be invoked only for the first slice segment of a 
+    // picture.
+    x832DecProcForRefPicSet    (  false );
+  }
+  else if( m_decProcPocAndRps == ANNEX_F )
+  {
+    // F.8.1.3 Common decoding process for a coded picture
+
+    if (nuhLayerId == 0 )
+    {
+      // F.8.1.4 Decoding process for a coded picture with nuh_layer_id equal to
+      // --> Clause 8.1.3 is invoked with replacments of 8.3.1, 8.3.2, and 8.3.3 by F.8.3.1, 8.3.2, and 8.3.3
+
+      // Variables and functions relating to picture order count are derived as 
+      // specified in clause 8.3.1. This needs to be invoked only for the first slice 
+      // segment of a picture.
+      xF831DecProcForPicOrderCount( );
+
+      // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference 
+      // pictures may be marked as "unused for reference" or "used for long-term 
+      // reference". This needs to be invoked only for the first slice segment of a 
+      // picture.
+      xF832DecProcForRefPicSet( );
+    }
+    else
+    {
+      // F.8.1.5 Decoding process for starting the decoding of a coded picture with
+      // nuh_layer_id greater than 0
+
+      // Variables and functions relating to picture order count are derived in clause F.8.3.1. 
+      // This needs to be invoked only for the first slice segment of a picture. It is a requirement 
+      // of bitstream conformance that PicOrderCntVal of each picture in an access unit shall have the 
+      // same value during and at the end of decoding of the access unit
+      xF831DecProcForPicOrderCount( );
+
+      // The decoding process for RPS in clause F.8.3.2 is invoked, wherein only reference pictures with 
+      // nuh_layer_id equal to that of CurrPic may be marked as "unused for reference" or "used for 
+      // long-term reference" and any picture with a different value of nuh_layer_id is not marked. 
+      // This needs to be invoked only for the first slice segment of a picture.
+      xF832DecProcForRefPicSet( );
+    }
+  }
+  else
+  {
+    assert( false ); 
+  }
+}
+
+Void TDecTop::genUnavailableRefPics( )
+{ 
+  assert( m_uiSliceIdx == 0 );
+  Int nuhLayerId = m_pcPic->getLayerId();
+  if ( m_decProcPocAndRps == CLAUSE_8 )
+  {
+    // 8.1.3 Decoding process for a coded picture with nuh_layer_id equal to 0
+
+    if ( m_pcPic->isBla() || ( m_pcPic->isCra() && m_pcPic->getNoRaslOutputFlag() ) )
+    {
+      // When the current picture is a BLA picture or is a CRA picture 
+      // with NoRaslOutputFlag equal to 1, the decoding process for generating 
+      // unavailable reference pictures specified in clause 8.3.3 is invoked, 
+      // which needs to be invoked only for the first slice segment of a picture.
+      x8331GenDecProcForGenUnavilRefPics();       
+    }
+  }
+  else if( m_decProcPocAndRps == ANNEX_F )
+  {
+    // F.8.1.3 Common decoding process for a coded picture
+
+    if (nuhLayerId == 0 )
+    {
+      // F.8.1.4 Decoding process for a coded picture with nuh_layer_id equal to
+      // --> Clause 8.1.3 is invoked with replacments of 8.3.1, 8.3.2, and 8.3.3 by F.8.3.1, 8.3.2, and 8.3.3
+
+      if ( m_pcPic->isBla() || ( m_pcPic->isCra() && m_pcPic->getNoRaslOutputFlag() ) )
+      {
+        // When the current picture is a BLA picture or is a CRA picture 
+        // with NoRaslOutputFlag equal to 1, the decoding process for generating 
+        // unavailable reference pictures specified in clause 8.3.3 is invoked, 
+        // which needs to be invoked only for the first slice segment of a picture.
+        xF833DecProcForGenUnavRefPics(); 
+      }
+#if NH_MV_FIX_INIT_NUM_ACTIVE_REF_LAYER_PICS
+      TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+      decRps->m_numActiveRefLayerPics0 = 0;
+      decRps->m_numActiveRefLayerPics1 = 0;      
+#endif
+    }
+    else
+    {
+      // F.8.1.5 Decoding process for starting the decoding of a coded picture with
+      // nuh_layer_id greater than 0
+
+      if ( !m_firstPicInLayerDecodedFlag[ nuhLayerId ] )
+      {
+        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 0, the decoding process for generating 
+        // unavailable reference pictures for pictures first in decoding order within a layer specified in 
+        // clause F.8.1.7 is invoked, which needs to be invoked only for the first slice segment of a picture.
+        xF817DecProcForGenUnavRefPicForPicsFrstInDecOrderInLay();
+      }
+
+      if ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] && ( m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag() ) )
+      {
+        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 1 and the current picture is an IRAP 
+        // picture with NoRaslOutputFlag equal to 1, the decoding process for generating unavailable reference 
+        // pictures specified in clause F.8.3.3 is invoked, which needs to be invoked only for the first slice 
+        // segment of a picture.
+        xF833DecProcForGenUnavRefPics(); 
+      }
+
+      if ( decProcAnnexG() )
+      {
+        // G.1.2 --> G.1.3
+        xG813DecProcForInterLayerRefPicSet();
+      }
+    }
+  }
+  else
+  {
+    assert( false ); 
+  }
+
+  xCheckUnavailableRefPics();      
+}
+Void TDecTop::executeLoopFilters( )
+{
+  assert( m_pcPic != NULL ); 
+  if ( !m_pcPic->getHasGeneratedRefPics() && !m_pcPic->getIsGenerated() )
+  {
+    m_cGopDecoder.filterPicture( m_pcPic );
+  }
+  m_cCuDecoder.destroy();
+}
+
+Void TDecTop::finalizePic()
+{
+  if( m_pcPic->isIrap() )
+  {
+    m_prevIrapPoc           = m_pcPic->getPOC(); 
+    m_prevIrapDecodingOrder = m_pcPic->getDecodingOrder(); 
+  }
+  if( m_pcPic->isStsa() )
+  {
+    m_prevStsaDecOrder      = m_pcPic->getDecodingOrder();
+    m_prevStsaTemporalId    = m_pcPic->getTemporalId()   ;
+  }
+}
+
+
+Void TDecTop::initFromActiveVps( const TComVPS* vps )
+{   
+  setViewId   ( vps->getViewId   ( getLayerId() )      );  
+#if NH_3D
+  setViewIndex( vps->getViewIndex( getLayerId() )      );  
+  setIsDepth  ( vps->getDepthId  ( getLayerId() ) == 1 );  
+#endif
+
+  if ( !vps->getVpsExtensionFlag() )
+  {
+    m_decodingProcess = CLAUSE_8; 
+    m_isInOwnTargetDecLayerIdList = ( getLayerId() ==  0 );
+  }
+  else
+  {  
+    if ( m_targetOlsIdx == -1 )
+    {
+      // Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
+      m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1(); 
+    }
+
+    Int targetDecLayerSetIdx = vps->olsIdxToLsIdx( m_targetOlsIdx ); 
+
+    if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && vps->getVpsBaseLayerInternalFlag() )
+    {
+      m_smallestLayerId = 0; 
+    }
+    else if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && !vps->getVpsBaseLayerInternalFlag() )
+    {
+      m_smallestLayerId = 0; 
+    }
+    else if ( targetDecLayerSetIdx > vps->getVpsNumLayerSetsMinus1() && vps->getNumLayersInIdList( targetDecLayerSetIdx) == 1 )
+    {
+      
+      // m_smallestLayerId = 0;       
+      // For now don't do change of layer id here. 
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+    }
+    else
+    {
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+    }
+
+
+    // Set profile
+    Int lsIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
+    Int lIdx = -1; 
+    for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ) ; j++ )
+    {
+      if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
+      {        
+        lIdx = j;         
+        break; 
+      }        
+    }
+    m_isInOwnTargetDecLayerIdList = (lIdx != -1); 
+
+    if ( m_isInOwnTargetDecLayerIdList )
+    {
+      Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOlsIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
+      assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
+
+      if (  profileIdc == 6 )
+      {
+        m_decodingProcess = ANNEX_G;
+      }
+      else if (profileIdc == 7 )
+      {
+        m_decodingProcess = ANNEX_H;
+      }
+      else if (profileIdc == 8 )
+      {
+        m_decodingProcess = ANNEX_I;
+      }
+    }
+  }
+}
+
+
+Bool TDecTop::getFirstSliceSegementInPicFlag()
+{
+  return m_apcSlicePilot->getFirstSliceSegementInPicFlag();
+}
+
+Void TDecTop::x831DecProcForPicOrderCount()
+{
+  /////////////////////////////////////////////////////
+  // 8.3.1 Decoding process for picture order count //
+  /////////////////////////////////////////////////////
+
+  //  Output of this process is PicOrderCntVal, the picture order count of the current picture.
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  motion vector prediction, and for decoder conformance checking (see clause C.5).
+  //  Each coded picture is associated with a picture order count variable, denoted as PicOrderCntVal.
+
+  const TComSlice* curSlice = m_pcPic->getSlice(0); 
+
+  Int prevPicOrderCntLsb = MIN_INT; 
+  Int prevPicOrderCntMsb = MIN_INT;  
+  if (!(m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag() )  )  
+  {
+    //  When the current picture is not an IRAP picture with NoRaslOutputFlag equal to 1, 
+    //  the variables prevPicOrderCntLsb and prevPicOrderCntMsb are derived as follows:
+
+    //  -  Let prevTid0Pic be the previous picture in decoding order that has TemporalId equal to 0 and that is not a RASL picture, 
+    //     a RADL picture or an SLNR picture.
+
+    //  -  The variable prevPicOrderCntLsb is set equal to slice_pic_order_cnt_lsb of prevTid0Pic.
+    prevPicOrderCntLsb = m_prevTid0PicSlicePicOrderCntLsb; 
+
+    //  -  The variable prevPicOrderCntMsb is set equal to PicOrderCntMsb of prevTid0Pic.
+    prevPicOrderCntMsb = m_prevTid0PicPicOrderCntMsb; 
+  }
+
+  //  The variable PicOrderCntMsb of the current picture is derived as follows:  
+  
+  Int slicePicOrderCntLsb = curSlice->getSlicePicOrderCntLsb();
+
+  Int picOrderCntMsb; 
+
+  if (m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag()  )
+  {
+    //-  If the current picture is an IRAP picture with NoRaslOutputFlag equal to 1, PicOrderCntMsb is set equal to 0.
+    picOrderCntMsb = 0; 
+  }
+  else
+  {
+    Int maxPicOrderCntLsb   = curSlice->getSPS()->getMaxPicOrderCntLsb(); 
+
+  //  -  Otherwise, PicOrderCntMsb is derived as follows:
+
+    if( ( slicePicOrderCntLsb < prevPicOrderCntLsb )  &&
+      ( ( prevPicOrderCntLsb - slicePicOrderCntLsb )  >=  ( maxPicOrderCntLsb / 2 ) ) )
+    {
+      picOrderCntMsb = prevPicOrderCntMsb + maxPicOrderCntLsb;   // (8 1)
+    }
+    else if( (slicePicOrderCntLsb > prevPicOrderCntLsb )  &&
+    ( ( slicePicOrderCntLsb - prevPicOrderCntLsb ) > ( maxPicOrderCntLsb / 2 ) ) )
+    {
+      picOrderCntMsb = prevPicOrderCntMsb - maxPicOrderCntLsb;
+    }
+    else
+    {
+      picOrderCntMsb = prevPicOrderCntMsb; 
+    }
+  }
+  
+  //PicOrderCntVal is derived as follows:
+  Int picOrderCntVal = picOrderCntMsb + slicePicOrderCntLsb; //   (8 2)
+
+  //  NOTE 1 - All IDR pictures will have PicOrderCntVal equal to 0 since slice_pic_order_cnt_lsb is inferred to be 0 for IDR 
+  //  pictures and prevPicOrderCntLsb and prevPicOrderCntMsb are both set equal to 0.
+
+  m_pcPic->getSlice(0)->setPOC( picOrderCntVal ); 
+
+  // Update prevTid0Pic
+  //   Let prevTid0Pic be the previous picture in decoding order that has TemporalId equal to 0 and that is not a RASL picture, a RADL picture or an SLNR picture.
+  if( curSlice->getTemporalId() == 0  && !m_pcPic->isRasl() && !m_pcPic->isRadl() && !m_pcPic->isSlnr() )
+  {
+    m_prevTid0PicSlicePicOrderCntLsb = slicePicOrderCntLsb;     
+    m_prevTid0PicPicOrderCntMsb      = picOrderCntMsb;  
+  }
+}
+
+Void TDecTop::xF831DecProcForPicOrderCount()
+{
+  //Output of this process is PicOrderCntVal, the picture order count of the current picture.
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  motion vector prediction and for decoder conformance checking (see clause F.13.5).
+
+  //  Each coded picture is associated with a picture order count variable, denoted as PicOrderCntVal.
+
+  const TComSlice* slice = m_pcPic->getSlice(0); 
+  const Int nuhLayerId   = m_pcPic->getLayerId(); 
+  const TComVPS*   vps   = slice->getVPS(); 
+  const TComSPS*   sps   = slice->getSPS(); 
+  if ( m_pcPic->getIsFstPicOfAllLayOfPocResetPer() )
+  {
+    //  When the current picture is the first picture among all layers of a POC resetting period, 
+    //  the variable PocDecrementedInDPBFlag[ i ] is set equal to 0 for each value of i in the range of 0 to 62, inclusive.
+    for (Int i = 0; i <= 62; i++)
+    {
+      m_pocDecrementedInDpbFlag[ i ] = 0; 
+    }
+  }
+
+  //  The variable pocResettingFlag is derived as follows:
+  Bool pocResettingFlag; 
+  if (m_pcPic->getIsPocResettingPic() )
+  {
+    //-  If the current picture is a POC resetting picture, the following applies:    
+    if( vps->getVpsPocLsbAlignedFlag()  )
+    {
+      //  -  If vps_poc_lsb_aligned_flag is equal to 0, pocResettingFlag is set equal to 1.
+      pocResettingFlag = true; 
+    }
+    else if ( m_pocDecrementedInDpbFlag[ nuhLayerId ] )
+    {
+      //  -  Otherwise, if PocDecrementedInDPBFlag[ nuh_layer_id ] is equal to 1, pocResettingFlag is set equal to 0.
+      pocResettingFlag = false; 
+    }
+    else
+    {
+      //  -  Otherwise, pocResettingFlag is set equal to 1.
+      pocResettingFlag = true; 
+    }
+  }
+  else
+  {
+    //  -  Otherwise, pocResettingFlag is set equal to 0.
+    pocResettingFlag = false; 
+  }
+
+  //  The list affectedLayerList is derived as follows:
+  std::vector<Int> affectedLayerList; 
+  if (! vps->getVpsPocLsbAlignedFlag() )
+  {
+    //-  If vps_poc_lsb_aligned_flag is equal to 0, affectedLayerList consists of the nuh_layer_id of the current picture.
+    affectedLayerList.push_back( nuhLayerId ); 
+  }
+  else
+  {
+    //  -  Otherwise, affectedLayerList consists of the nuh_layer_id of the current picture and the nuh_layer_id values 
+    //     equal to IdPredictedLayer[ currNuhLayerId ][ j ] for all values of j in the range of 0 to NumPredictedLayers[ currNuhLayerId ] - 1, 
+    //     inclusive, where currNuhLayerId is the nuh_layer_id value of the current picture.
+    affectedLayerList.push_back( nuhLayerId ); 
+    Int currNuhLayerId = nuhLayerId; 
+    for (Int j = 0; j <= vps->getNumPredictedLayers( currNuhLayerId )-1; j++ )
+    {
+      affectedLayerList.push_back( vps->getIdPredictedLayer(currNuhLayerId, j ) );
+    }
+  }
+  
+  Int picOrderCntMsb; 
+  Int picOrderCntVal; 
+
+  //  Depending on pocResettingFlag, the following applies:
+  if ( pocResettingFlag )
+  {
+    //-  If pocResettingFlag is equal to 1, the following applies:
+    if ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] )
+    {
+      //-  The variables pocMsbDelta, pocLsbDelta and DeltaPocVal are derived as follows:
+      Int pocMsbDelta; 
+      Int pocLsbDelta; 
+      Int deltaPocVal;       
+
+      {
+        Int pocLsbVal; 
+        Int prevPicOrderCntLsb; 
+        Int prevPicOrderCntMsb; 
+
+        if( slice->getPocResetIdc() ==  3 )
+        {
+          pocLsbVal = slice->getPocLsbVal(); 
+        }      
+        else
+        {
+          pocLsbVal = slice->getSlicePicOrderCntLsb(); 
+        }
+
+        if( slice->getPocMsbCycleValPresentFlag() )
+        {
+          pocMsbDelta = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb();   // (F 60)
+        }      
+        else
+        {
+          prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 ); 
+          prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
+
+          pocMsbDelta = xGetCurrMsb( pocLsbVal, prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
+        }
+
+        if( slice->getPocResetIdc() == 2 ||  ( slice->getPocResetIdc() == 3  &&  slice->getFullPocResetFlag() ) )
+        {
+          pocLsbDelta = pocLsbVal; 
+        }
+        else
+        {
+          pocLsbDelta = 0; 
+        }
+        deltaPocVal = pocMsbDelta + pocLsbDelta; 
+      }
+
+      //-  The PicOrderCntVal of each picture that has nuh_layer_id value nuhLayerId for which PocDecrementedInDPBFlag[ nuhLayerId ] is equal to 0 
+      //   and that is equal to any value in affectedLayerList is decremented by DeltaPocVal.
+      for (Int i = 0; i < (Int) affectedLayerList.size(); i++ )
+      {
+        if ( !m_pocDecrementedInDpbFlag[ affectedLayerList[i] ] )
+        {
+          m_dpb->decrementPocsInSubDpb( affectedLayerList[i], deltaPocVal ); 
+        }
+      }
+
+      //-  PocDecrementedInDPBFlag[ nuhLayerId ] is set equal to 1 for each value of nuhLayerId included in affectedLayerList.
+      for (Int i = 0; i < (Int) affectedLayerList.size(); i++ )
+      {
+        m_pocDecrementedInDpbFlag[ affectedLayerList[i] ] = true; 
+      }
+    } 
+
+    //-  The PicOrderCntVal of the current picture is derived as follows:
+    if( slice->getPocResetIdc()  ==  1 )
+    {
+      picOrderCntVal = slice->getSlicePicOrderCntLsb(); 
+    }
+    else if (slice->getPocResetIdc()  ==  2 ) 
+    {
+      picOrderCntVal = 0; 
+    }
+    else
+    {
+       picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() ); 
+       picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+    }
+  }
+  else
+  {
+    //-  Otherwise (pocResettingFlag is equal to 0), the following applies:
+    //-  The PicOrderCntVal of the current picture is derived as follows:
+    
+    if( slice->getPocMsbCycleValPresentFlag() )
+    {
+      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb(); 
+    }
+    else if( !m_firstPicInLayerDecodedFlag[ nuhLayerId ]  ||
+    slice->getNalUnitType()  ==  NAL_UNIT_CODED_SLICE_IDR_N_LP || slice->getNalUnitType() ==  NAL_UNIT_CODED_SLICE_IDR_W_RADL )
+    {
+      picOrderCntMsb = 0; //     (F 62)
+    }    
+    else
+    {
+        Int prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 );
+        Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
+        picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
+    }
+    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+  }
+  
+  m_pcPic->getSlice(0)->setPOC( picOrderCntVal ); 
+  
+  for (Int lId = 0; lId < (Int) affectedLayerList.size(); lId++ )
+  {  
+    //  The value of PrevPicOrderCnt[ lId ] for each of the lId values included in affectedLayerList is derived as follows:
+
+    if (!m_pcPic->isRasl() && !m_pcPic->isRadl() && !m_pcPic->isSlnr() && slice->getTemporalId() == 0 && !slice->getDiscardableFlag() )
+    {
+      //-  If the current picture is not a RASL picture, a RADL picture or a sub-layer non-reference picture, and the current picture 
+      //   has TemporalId equal to 0 and discardable_flag equal to 0, PrevPicOrderCnt[ lId ] is set equal to PicOrderCntVal.
+      m_prevPicOrderCnt = picOrderCntVal; 
+    }
+    else if ( slice->getPocResetIdc() == 3 &&  (
+      ( !m_firstPicInLayerDecodedFlag[ nuhLayerId ]) || 
+      ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] && m_pcPic->getIsPocResettingPic() ) 
+      ) )
+    {
+      //  -  Otherwise, when poc_reset_idc is equal to 3 and one of the following conditions is true, PrevPicOrderCnt[ lId ] is set equal to ( full_poc_reset_flag ? 0 : poc_lsb_val ):
+      //     -  FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 0.
+      //     -  FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 1 and the current picture is a POC resetting picture.
+      m_prevPicOrderCnt = ( slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal() ); 
+    }
+  }
+}
+
+Int TDecTop::xGetCurrMsb( Int cl, Int pl, Int pm, Int ml )
+{
+  Int currMsb; 
+  if ((pl - cl) >= (ml/ 2))
+  {
+    currMsb = pm + ml;
+  }
+  else if ( (cl - pl) > (ml / 2))
+  {
+    currMsb = pm - ml; 
+  }
+  else
+  {
+    currMsb = pm; 
+  }
+
+  return currMsb;  
+}   
+
+
+
+Void TDecTop::x832DecProcForRefPicSet(  Bool annexFModifications )
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // 8.3.2 8.3.2 Decoding process for reference picture set
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  TComSlice* slice = m_pcPic->getSlice( 0 ); 
+  const TComSPS* sps = slice->getSPS(); 
+  //  This process is invoked once per picture, after decoding of a slice header but prior to the decoding of any coding unit and prior 
+  //  to the decoding process for reference picture list construction for the slice as specified in clause 8.3.3. 
+  //  This process may result in one or more reference pictures in the DPB being marked as "unused for reference" or 
+  //  "used for long-term reference".
+
+  // The variable currPicLayerId is set equal to nuh_layer_id of the current picture.
+  Int currPicLayerId = m_pcPic->getLayerId(); 
+  Int picOrderCntVal = m_pcPic->getPOC(); 
+
+  if (m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag()  )
+  {     
+    // When the current picture is an IRAP picture with NoRaslOutputFlag equal to 1, 
+    // all reference pictures with nuh_layer_id equal to currPicLayerId currently in the 
+    // DPB (if any) are marked as "unused for reference".
+    m_dpb->markSubDpbAsUnusedForReference( currPicLayerId ); 
+  }
+  // Short-term reference pictures are identified by their PicOrderCntVal values. Long-term reference pictures are identified either by 
+  // their PicOrderCntVal values or their slice_pic_order_cnt_lsb values.
+
+  // Five lists of picture order count values are constructed to derive the RPS. These five lists are PocStCurrBefore, 
+  // PocStCurrAfter, PocStFoll, PocLtCurr and PocLtFoll, with NumPocStCurrBefore, NumPocStCurrAfter, NumPocStFoll, 
+  // NumPocLtCurr and NumPocLtFoll number of elements, respectively. The five lists and the five variables are derived as follows:
+  
+  TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+
+  std::vector<Int>& pocStCurrBefore = decRps->m_pocStCurrBefore;
+  std::vector<Int>& pocStCurrAfter  = decRps->m_pocStCurrAfter;
+  std::vector<Int>& pocStFoll       = decRps->m_pocStFoll;
+  std::vector<Int>& pocLtCurr       = decRps->m_pocLtCurr;
+  std::vector<Int>& pocLtFoll       = decRps->m_pocLtFoll;
+
+  Int& numPocStCurrBefore = decRps->m_numPocStCurrBefore; 
+  Int& numPocStCurrAfter  = decRps->m_numPocStCurrAfter;
+  Int& numPocStFoll       = decRps->m_numPocStFoll;
+  Int& numPocLtCurr       = decRps->m_numPocLtCurr;
+  Int& numPocLtFoll       = decRps->m_numPocLtFoll;   
+
+  std::vector<Int> currDeltaPocMsbPresentFlag, follDeltaPocMsbPresentFlag; 
+
+  if (m_pcPic->isIdr() )
+  {
+    // - If the current picture is an IDR picture, PocStCurrBefore, PocStCurrAfter, PocStFoll, 
+    //   PocLtCurr and PocLtFoll are all set to be empty, and NumPocStCurrBefore, 
+    //   NumPocStCurrAfter, NumPocStFoll, NumPocLtCurr and NumPocLtFoll are all set equal to 0.
+
+    pocStCurrBefore.clear();
+    pocStCurrAfter .clear();
+    pocStFoll      .clear();
+    pocLtCurr      .clear();
+    pocLtFoll      .clear();
+    numPocStCurrBefore = 0; 
+    numPocStCurrAfter  = 0; 
+    numPocStFoll       = 0; 
+    numPocLtCurr       = 0; 
+    numPocLtFoll       = 0; 
+  }
+  else
+  {
+    const TComStRefPicSet* stRps  = slice->getStRps( slice->getCurrRpsIdx() );
+    // -  Otherwise, the following applies:
+
+    Int j = 0; 
+    Int k = 0; 
+    for( Int i = 0; i < stRps->getNumNegativePicsVar() ; i++ )
+    {
+      if( stRps->getUsedByCurrPicS0Var( i  ) )
+      {
+        pocStCurrBefore.push_back( picOrderCntVal + stRps->getDeltaPocS0Var( i ) ); j++;
+      }
+      else
+      {
+        pocStFoll      .push_back( picOrderCntVal + stRps->getDeltaPocS0Var( i ) ); k++;
+      }
+    }
+    numPocStCurrBefore = j;    
+
+    j = 0; 
+    for (Int i = 0; i < stRps->getNumPositivePicsVar(); i++ )
+    {
+      if (stRps->getUsedByCurrPicS1Var( i ) )
+      {
+        pocStCurrAfter.push_back( picOrderCntVal + stRps->getDeltaPocS1Var( i ) ); j++; 
+      }
+      else
+      {
+        pocStFoll     .push_back( picOrderCntVal + stRps->getDeltaPocS1Var( i ) ); k++;
+      }
+    }
+    numPocStCurrAfter = j;
+    numPocStFoll = k; //    (8 5)
+
+
+    j = 0; 
+    k = 0; 
+    for( Int i = 0; i < slice->getNumLongTermSps( ) + slice->getNumLongTermPics(); i++ )
+    {
+      Int pocLt = slice->getPocLsbLtVar( i ); 
+      if( slice->getDeltaPocMsbPresentFlag( i ) )
+      {
+        pocLt  +=  picOrderCntVal - slice->getDeltaPocMsbCycleLtVar( i ) * sps->getMaxPicOrderCntLsb() -
+          ( picOrderCntVal & ( sps->getMaxPicOrderCntLsb() - 1 ) );
+      }
+
+      if( slice->getUsedByCurrPicLtVar(i)) 
+      {
+        pocLtCurr.push_back( pocLt );
+        currDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); j++; 
+      } 
+      else
+      {
+        pocLtFoll.push_back( pocLt );
+        follDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); k++; 
+      }
+    }
+    numPocLtCurr = j;
+    numPocLtFoll = k;
+  }
+
+  assert(numPocStCurrAfter  == pocStCurrAfter   .size() );
+  assert(numPocStCurrBefore == pocStCurrBefore  .size() );
+  assert(numPocStFoll       == pocStFoll        .size() );  
+  assert(numPocLtCurr       == pocLtCurr        .size() );  
+  assert(numPocLtFoll       == pocLtFoll        .size() );
+
+  // where PicOrderCntVal is the picture order count of the current picture as specified in clause 8.3.1.
+
+  //   NOTE 2 - A value of CurrRpsIdx in the range of 0 to num_short_term_ref_pic_sets - 1, inclusive, 
+  //   indicates that a candidate short-term RPS from the active SPS for the current layer is being used, 
+  //   where CurrRpsIdx is the index of the candidate short-term RPS into the list of candidate short-term RPSs signalled 
+  //   in the active SPS for the current layer. CurrRpsIdx equal to num_short_term_ref_pic_sets indicates that 
+  //   the short-term RPS of the current picture is directly signalled in the slice header.
+
+  for (Int i = 0; i <= numPocLtCurr - 1; i++  )
+  {
+      // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 1, 
+      // it is a requirement of bitstream conformance that the following conditions apply:
+    if ( currDeltaPocMsbPresentFlag[i] )
+    {
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      //    for which PocLtCurr[ i ] is equal to PocStCurrBefore[ j ].
+      for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == pocStCurrBefore[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive, 
+      //    for which PocLtCurr[ i ] is equal to PocStCurrAfter[ j ]. 
+      for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == pocStCurrAfter[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive, 
+      //    for which PocLtCurr[ i ] is equal to PocStFoll[ j ].
+      for (Int j = 0; j <= numPocStFoll - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == pocStFoll[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive, 
+      //    where j is not equal to i, for which PocLtCurr[ i ] is equal to PocLtCurr[ j ].
+      for (Int j = 0; j <= numPocLtCurr - 1; j++ )
+      {
+        if ( i != j )
+        {        
+          assert(!( pocLtCurr[ i ] == pocLtCurr[ j ] ) );
+        }
+      }
+    }
+  }
+
+  for (Int i = 0; i <= numPocLtFoll - 1; i++  )
+  {
+    // For each i in the range of 0 to NumPocLtFoll - 1, inclusive, when FollDeltaPocMsbPresentFlag[ i ] is equal to 1, 
+    // it is a requirement of bitstream conformance that the following conditions apply:
+    if ( follDeltaPocMsbPresentFlag[i] )
+    {
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      //    for which PocLtFoll[ i ] is equal to PocStCurrBefore[ j ].
+      for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == pocStCurrBefore[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive, 
+      //    for which PocLtFoll[ i ] is equal to PocStCurrAfter[ j ].
+      for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == pocStCurrAfter[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive, 
+      //    for which PocLtFoll[ i ] is equal to PocStFoll[ j ].
+      for (Int j = 0; j <= numPocStFoll - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == pocStFoll[ j ] ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtFoll - 1, inclusive, 
+      //    where j is not equal to i, for which PocLtFoll[ i ] is equal to PocLtFoll[ j ].
+      for (Int j = 0; j <= numPocLtFoll - 1; j++ )
+      {
+        if (j != i)
+        {
+          assert(!( pocLtFoll[ i ] == pocLtFoll[ j ] ) );
+        }
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive, 
+      //    for which PocLtFoll[ i ] is equal to PocLtCurr[ j ].
+      for (Int j = 0; j <= numPocLtCurr - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == pocLtCurr[ j ] ) );
+      }
+    }
+  }
+
+  Int maxPicOrderCntLsb = sps->getMaxPicOrderCntLsb(); 
+  for (Int i = 0; i <= numPocLtCurr - 1; i++  )
+  {
+    // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 0, 
+    // it is a requirement of bitstream conformance that the following conditions apply:
+    if ( currDeltaPocMsbPresentFlag[ i ] == 0  )
+    {
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      //    for which PocLtCurr[ i ] is equal to ( PocStCurrBefore[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == ( pocStCurrBefore[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive,
+      //    for which PocLtCurr[ i ] is equal to ( PocStCurrAfter[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == ( pocStCurrAfter[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive,
+      //    for which PocLtCurr[ i ] is equal to ( PocStFoll[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStFoll - 1; j++ )
+      {
+        assert(!( pocLtCurr[ i ] == ( pocStFoll[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive,
+      //    where j is not equal to i, for which PocLtCurr[ i ] is equal to ( PocLtCurr[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocLtCurr - 1; j++ )
+      {
+        if (j != i)
+        {
+          assert(!( pocLtCurr[ i ] == ( pocLtCurr[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+        }
+      }
+    }
+  }
+
+  for (Int i = 0; i <= numPocLtFoll - 1; i++  )
+  {
+    // For each i in the range of 0 to NumPocLtFoll - 1, inclusive, when FollDeltaPocMsbPresentFlag[ i ] is equal to 0, 
+    // it is a requirement of bitstream conformance that the following conditions apply:
+    if ( follDeltaPocMsbPresentFlag[ i ] == 0  )
+    {
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive,
+      //    for which PocLtFoll[ i ] is equal to ( PocStCurrBefore[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == ( pocStCurrBefore[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive,
+      //    for which PocLtFoll[ i ] is equal to ( PocStCurrAfter[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == ( pocStCurrAfter[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive,
+      //    for which PocLtFoll[ i ] is equal to ( PocStFoll[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocStFoll - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == ( pocStFoll[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtFoll - 1, inclusive,
+      //    where j is not equal to i, for which PocLtFoll[ i ] is equal to ( PocLtFoll[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocLtFoll - 1; j++ )
+      {
+        if (j != i)
+        {
+          assert(!( pocLtFoll[ i ] == ( pocLtFoll[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+        }          
+      }
+
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive,
+      //    for which PocLtFoll[ i ] is equal to ( PocLtCurr[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
+      for (Int j = 0; j <= numPocLtCurr - 1; j++ )
+      {
+        assert(!( pocLtFoll[ i ] == ( pocLtCurr[ j ] & ( maxPicOrderCntLsb - 1 ) ) ) );
+      }
+    }
+  }
+
+  if ( !annexFModifications )
+  {  
+    // The variable NumPicTotalCurr is derived as specified in clause 7.4.7.2. 
+
+    // It is a requirement of bitstream conformance that the following applies to the value of NumPicTotalCurr:
+    if ( m_pcPic->isBla() || m_pcPic->isCra() )
+    {
+      // -  If the current picture is a BLA or CRA picture, the value of NumPicTotalCurr shall be equal to 0.
+      assert( slice->getNumPicTotalCurr() == 0 ); 
+    }
+    else
+    {
+      // -  Otherwise, 
+      if ( slice->isInterP() || slice->isInterB() )
+      {
+        // when the current picture contains a P or B slice, the value of NumPicTotalCurr shall not be equal to 0.
+        assert( slice->getNumPicTotalCurr() != 0 ); 
+      }
+    }
+  }
+    
+  // The RPS of the current picture consists of five RPS lists; RefPicSetStCurrBefore, RefPicSetStCurrAfter, RefPicSetStFoll, 
+  // RefPicSetLtCurr and RefPicSetLtFoll. RefPicSetStCurrBefore, RefPicSetStCurrAfter and RefPicSetStFoll are collectively 
+  // referred to as the short-term RPS. RefPicSetLtCurr and RefPicSetLtFoll are collectively referred to as the long-term RPS.
+
+  std::vector<TComPic*>& refPicSetStCurrBefore = decRps->m_refPicSetStCurrBefore;
+  std::vector<TComPic*>& refPicSetStCurrAfter  = decRps->m_refPicSetStCurrAfter ;
+  std::vector<TComPic*>& refPicSetStFoll       = decRps->m_refPicSetStFoll      ;
+  std::vector<TComPic*>& refPicSetLtCurr       = decRps->m_refPicSetLtCurr      ;
+  std::vector<TComPic*>& refPicSetLtFoll       = decRps->m_refPicSetLtFoll      ;
+  
+  std::vector<TComPic*>** refPicSetsCurr       = decRps->m_refPicSetsCurr       ;
+  std::vector<TComPic*>** refPicSetsLt         = decRps->m_refPicSetsLt         ;
+  std::vector<TComPic*>** refPicSetsAll        = decRps->m_refPicSetsAll        ;
+  //   NOTE 3 - RefPicSetStCurrBefore, RefPicSetStCurrAfter and RefPicSetLtCurr contain all reference pictures that may be 
+  //   used for inter prediction of the current picture and one or more pictures that follow the current picture in decoding order.
+  //   RefPicSetStFoll and RefPicSetLtFoll consist of all reference pictures that are not used for inter prediction of the current 
+  //   picture but may be used in inter prediction for one or more pictures that follow the current picture in decoding order.
+
+  // The derivation process for the RPS and picture marking are performed according to the following ordered steps:
+  // 1.  The following applies:
+
+  TComSubDpb* dpb = m_dpb->getSubDpb( getLayerId(), false );   
+  assert( refPicSetLtCurr.empty() );
+  for( Int i = 0; i < numPocLtCurr; i++ ) 
+  {
+    if( !currDeltaPocMsbPresentFlag[ i ] ) 
+    {    
+      refPicSetLtCurr.push_back( dpb->getPicFromLsb( pocLtCurr[ i ], maxPicOrderCntLsb ) );       
+    }
+    else
+    {
+      refPicSetLtCurr.push_back(dpb->getPic( pocLtCurr[ i ] ));       
+    }    
+  }
+
+  assert( refPicSetLtFoll.empty() );
+  for( Int i = 0; i < numPocLtFoll; i++ )
+  {
+   if( !follDeltaPocMsbPresentFlag[ i ] )
+   {
+     refPicSetLtFoll.push_back(dpb->getPicFromLsb(pocLtFoll[ i ], maxPicOrderCntLsb ));
+   }
+   else
+   {
+     refPicSetLtFoll.push_back(dpb->getPic( pocLtFoll[ i ] ));       
+   }
+  }
+  
+  // 2.  All reference pictures that are included in RefPicSetLtCurr or RefPicSetLtFoll and have nuh_layer_id equal 
+  //     to currPicLayerId are marked as "used for long-term reference".
+  for (Int i = 0; i < numPocLtCurr; i++)
+  {
+    if ( refPicSetLtCurr[i] != NULL )
+    {
+      refPicSetLtCurr[i]->markAsUsedForLongTermReference(); 
+    }    
+  }
+
+  for (Int i = 0; i < numPocLtFoll; i++)
+  {
+    if ( refPicSetLtFoll[i] != NULL )
+    {
+      refPicSetLtFoll[i]->markAsUsedForLongTermReference(); 
+    }    
+  }
+
+  // 3.  The following applies:
+  assert( refPicSetStCurrBefore.empty() );
+  for( Int i = 0; i < numPocStCurrBefore; i++ )
+  {
+    refPicSetStCurrBefore.push_back(dpb->getShortTermRefPic( pocStCurrBefore[ i ] )); 
+  }
+
+  assert( refPicSetStCurrAfter.empty() );
+  for( Int i = 0; i < numPocStCurrAfter; i++ )
+  {
+    refPicSetStCurrAfter.push_back(dpb->getShortTermRefPic( pocStCurrAfter[ i ] )); 
+  }
+
+  assert( refPicSetStFoll.empty() );
+  for( Int i = 0; i < numPocStFoll; i++ )
+  {
+    refPicSetStFoll.push_back(dpb->getShortTermRefPic( pocStFoll[ i ] )); 
+  }
+  
+  // 4.  All reference pictures in the DPB that are not included in RefPicSetLtCurr, RefPicSetLtFoll, RefPicSetStCurrBefore, 
+  //     RefPicSetStCurrAfter, or RefPicSetStFoll and have nuh_layer_id equal to currPicLayerId are marked as "unused for reference".
+  TComSubDpb picsToMark = (*dpb); 
+  for (Int j = 0; j < 5; j++ )
+  {
+    picsToMark.removePics( *refPicSetsAll[j] ); 
+  }  
+  picsToMark.markAllAsUnusedForReference(); 
+  
+  //     NOTE 4 - There may be one or more entries in the RPS lists that are equal to "no reference picture" because 
+  //     the corresponding pictures are not present in the DPB. Entries in RefPicSetStFoll or RefPicSetLtFoll that are equal 
+  //     to "no reference picture" should be ignored. An unintentional picture loss should be inferred for each entry in 
+  //     RefPicSetStCurrBefore, RefPicSetStCurrAfter, or RefPicSetLtCurr that is equal to "no reference picture".
+
+  //     NOTE 5 - A picture cannot be included in more than one of the five RPS lists.
+
+  
+  // It is a requirement of bitstream conformance that the RPS is restricted as follows:
+
+
+#if NH_MV_FIX_NO_REF_PICS_CHECK
+  if ( !annexFModifications || m_firstPicInLayerDecodedFlag[ m_pcPic->getLayerId() ] )
+  { 
+#endif
+    for (Int j = 0; j < 3; j++ )
+    {
+      // -  There shall be no entry in RefPicSetStCurrBefore, RefPicSetStCurrAfter or RefPicSetLtCurr 
+      //    for which one or more of the following are true:
+
+      std::vector<TComPic*>* currSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < currSet->size(); i++)
+      {
+        TComPic* pic = (*currSet)[i]; 
+
+        // -  The entry is equal to "no reference picture".
+        assert( ! (pic == NULL ) ); 
+
+        // -  The entry is an SLNR picture and has TemporalId equal to that of the current picture.
+        assert( !( pic->isSlnr() && pic->getTemporalId() == m_pcPic->getTemporalId() ) ); 
+
+        // -  The entry is a picture that has TemporalId greater than that of the current picture.
+        assert( !(  pic->getTemporalId() > m_pcPic->getTemporalId() ) ); 
+      }      
+    }
+#if NH_MV_FIX_NO_REF_PICS_CHECK
+  }
+#endif
+  
+  //  -  There shall be no entry in RefPicSetLtCurr or RefPicSetLtFoll for which the 
+  //     difference between the picture order count value of the current picture and the picture order count 
+  //     value of the entry is greater than or equal to 2^24.
+  for (Int j = 0; j < 2; j++ )
   {    
-    NalUnitType nut = m_apcSlicePilot->getNalUnitType(); 
-
-    Bool isBLA =  ( nut == NAL_UNIT_CODED_SLICE_BLA_W_LP  )  || ( nut == NAL_UNIT_CODED_SLICE_BLA_N_LP ) || ( nut == NAL_UNIT_CODED_SLICE_BLA_W_RADL ); 
-    Bool isIDR  = ( nut == NAL_UNIT_CODED_SLICE_IDR_W_RADL ) || ( nut == NAL_UNIT_CODED_SLICE_IDR_N_LP ); 
-    Bool noClrasOutputFlag  = isBLA || ( isIDR  &&  m_apcSlicePilot->getCrossLayerBlaFlag() ); 
-
-    if ( noClrasOutputFlag ) 
-    {
-      for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++)
-      {
-        m_layerInitilizedFlag[i] = false; 
-      } 
-    }
-  }
-}
-
-Bool TDecTop::xAllRefLayersInitilized( const TComVPS* vps )
-{
-  Bool allRefLayersInitilizedFlag = true;   
-  for (Int i = 0; i < vps->getNumDirectRefLayers( getLayerId()  ); i++ )
-  {
-    Int refLayerId = vps->getIdDirectRefLayer( m_layerId, i ); 
-    allRefLayersInitilizedFlag = allRefLayersInitilizedFlag && m_layerInitilizedFlag[ refLayerId ]; 
-  }
-
-  return allRefLayersInitilizedFlag;
-}
-
-
-Void TDecTop::initFromActiveVps( const TComVPS* vps )
-{
-  if ( m_targetOlsIdx == -1 )
-  {
-    // Not normative! Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
-    m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1(); 
-  }
-#if NH_3D
-  // Set profile
-  Int lsIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
-  Int lIdx = -1; 
-  for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ); j++ )
-  {
-    if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
-    {
-      lIdx = j; 
-      break; 
-    }        
-  }
-  assert( lIdx != -1 ); 
-
-  Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOlsIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
-  assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
-  m_profileIdc = profileIdc;   
-#endif
-}
+    std::vector<TComPic*>* ltSet = refPicSetsLt[j]; 
+    for (Int i = 0; i < ltSet->size(); i++)
+    {
+      TComPic* pic = (*ltSet)[i]; 
+      if( pic != NULL )
+      {
+        assert(!( abs( m_pcPic->getPOC() - pic->getPOC() ) >= (1 << 24) )); 
+      }
+    }
+  }
+
+  //   -  When the current picture is a temporal sub-layer access (TSA) picture, there shall be no picture 
+  //      included in the RPS with TemporalId greater than or equal to the TemporalId of the current picture.
+  if (m_pcPic->isTsa() )
+  {
+    for (Int j = 0; j < 5; j++ )
+    {    
+      std::vector<TComPic*>* aSet = refPicSetsAll[j]; 
+      for (Int i = 0; i < aSet->size(); i++)
+      {
+        TComPic* pic = (*aSet)[i]; 
+        if( pic != NULL )
+        {
+          assert( ! (pic->getTemporalId() >= m_pcPic->getTemporalId() ) ); 
+        }
+      }
+    }
+  }
+
+  //   -  When the current picture is a step-wise temporal sub-layer access (STSA) picture, 
+  //      there shall be no picture included in RefPicSetStCurrBefore, RefPicSetStCurrAfter or RefPicSetLtCurr that has
+  //      TemporalId equal to that of the current picture.
+  if (m_pcPic->isStsa() )
+  {
+    for (Int j = 0; j < 3; j++ )
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < cSet->size(); i++)
+      {
+        TComPic* pic = (*cSet)[i]; 
+        if( pic != NULL )
+        {
+          assert( ! (pic->getTemporalId() == m_pcPic->getTemporalId() ) ); 
+        }
+      }
+    }
+  }
+
+  //   -  When the current picture is a picture that follows, in decoding order, an STSA picture
+  //      that has TemporalId equal to that of the current picture, there shall be no picture that has
+  //      TemporalId equal to that of the current picture included in RefPicSetStCurrBefore, RefPicSetStCurrAfter
+  //      or RefPicSetLtCurr that precedes the STSA picture in decoding order.
+  if ( m_pcPic->getDecodingOrder() > m_prevStsaDecOrder && m_pcPic->getTemporalId() == m_prevStsaTemporalId  )
+  {
+    for (Int j = 0; j < 3; j++ )
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < cSet->size(); i++)
+      {
+        TComPic* pic = (*cSet)[i]; 
+        if( pic != NULL )
+        {
+          assert( ! (pic->getTemporalId() == m_pcPic->getTemporalId() && pic->getDecodingOrder() < m_prevStsaDecOrder  ) ); 
+        }
+      }
+    }
+  }
+  
+  //   -  When the current picture is a CRA picture, there shall be no picture included in the RPS that
+  //      precedes, in output order or decoding order, any preceding IRAP picture in decoding order (when present).
+  if ( m_pcPic->isCra() )
+  {
+    for (Int j = 0; j < 5; j++ )
+    {    
+      std::vector<TComPic*>* aSet = refPicSetsAll[j]; 
+      for (Int i = 0; i < aSet->size(); i++)
+      {
+        // TBD check whether it sufficient to test only the last IRAP
+        TComPic* pic = (*aSet)[i]; 
+        if( pic != NULL )
+        {        
+          assert( ! (pic->getPOC()           < m_prevIrapPoc           ) );           
+          assert( ! (pic->getDecodingOrder() < m_prevIrapDecodingOrder ) ); 
+        }
+      }
+    }
+  }
+  
+  Bool isTrailingPicture = ( !m_pcPic->isIrap() ) && ( m_pcPic->getPOC() > m_prevIrapPoc );
+  //   -  When the current picture is a trailing picture, there shall be no picture in RefPicSetStCurrBefore,
+  //      RefPicSetStCurrAfter or RefPicSetLtCurr that was generated by the decoding process for generating unavailable
+  //      reference pictures as specified in clause 8.3.3.
+  if ( isTrailingPicture )
+  {
+    for (Int j = 0; j < 3; j++ )
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < cSet->size(); i++)
+      {
+        TComPic* pic = (*cSet)[i]; 
+        if( pic != NULL )
+        {
+          assert( ! (pic->getIsGeneratedCl833() ) ); 
+        }
+      }
+    }
+  }
+
+  //   -  When the current picture is a trailing picture, there shall be no picture in the RPS that precedes the
+  //      associated IRAP picture in output order or decoding order.
+  if ( isTrailingPicture )
+  {
+    for (Int j = 0; j < 5; j++ )
+    {    
+      std::vector<TComPic*>* aSet = refPicSetsAll[j]; 
+      for (Int i = 0; i < aSet->size(); i++)
+      {
+        // TBD check whether it sufficient to test only the last IRAP
+         TComPic* pic = (*aSet)[i]; 
+        if( pic != NULL )
+        {         
+          assert( ! (pic->getPOC()           < m_prevIrapPoc           ) ); 
+          assert( ! (pic->getDecodingOrder() < m_prevIrapDecodingOrder ) ); 
+        }
+      }
+    }
+  }
+
+  //   -  When the current picture is a RADL picture, there shall be no picture included in RefPicSetStCurrBefore,
+  //      RefPicSetStCurrAfter or RefPicSetLtCurr that is any of the following:
+  if ( m_pcPic->isRadl() )
+  {
+    for (Int j = 0; j < 3; j++ )
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < cSet->size(); i++)
+      {        
+        TComPic* pic = (*cSet)[i]; 
+        if( pic != NULL )
+        {        
+          // -  A RASL picture
+          assert( ! (pic->isRasl() ) ); 
+          // -  A picture that was generated by the decoding process for generating unavailable reference pictures 
+          //    as specified in clause 8.3.3
+          assert( ! (pic->getIsGeneratedCl833() ) ); 
+          // -  A picture that precedes the associated IRAP picture in decoding order
+          assert( ! (pic->getDecodingOrder() < m_prevIrapDecodingOrder ) ); 
+        }
+      }
+    }
+  }
+  
+  
+  if ( sps->getTemporalIdNestingFlag() )
+  {
+    // -  When sps_temporal_id_nesting_flag is equal to 1, the following applies:
+    //    -  Let tIdA be the value of TemporalId of the current picture picA.
+    TComPic* picA = m_pcPic; 
+    Int      tIdA = picA->getTemporalId();
+    //   -  Any picture picB with TemporalId equal to tIdB that is less than or equal to tIdA shall not be included in 
+    //      RefPicSetStCurrBefore, RefPicSetStCurrAfter or RefPicSetLtCurr of picA when there exists a picture picC that 
+    //      has TemporalId less than tIdB, follows picB in decoding order, and precedes picA in decoding order.
+    for (Int j = 0; j < 3; j++ )
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      for (Int i = 0; i < cSet->size(); i++)
+      {
+        TComPic* picB = (*cSet)[i]; 
+        if( picB != NULL )
+        {
+          Int tIdB = picB->getTemporalId(); 
+
+          if (tIdB <= tIdA)
+          {
+            for ( TComSubDpb::iterator itP = dpb->begin(); itP != dpb->end(); itP++ )
+            {
+              TComPic* picC = (*itP); 
+              assert(! ( picC->getTemporalId() < tIdB && picC->getDecodingOrder() > picB->getDecodingOrder() && picC->getDecodingOrder() < picA->getDecodingOrder()  )  ); 
+            }
+          }
+        }
+      }
+    }
+  }    
+}
+
+
+Void TDecTop::xF832DecProcForRefPicSet()
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // F.8.3.2 Decoding process for reference picture set
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  // The specifications in clause 8.3.2 apply with the following changes:
+  // -  The references to clauses 7.4.7.2, 8.3.1, 8.3.3 and 8.3.4 are replaced with references to 
+  //    clauses F.7.4.7.2, F.8.3.1, F.8.3.3 and F.8.3.4, respectively.
+
+  x832DecProcForRefPicSet( true ); 
+
+  // -  The following specifications are added:
+  if (m_pcPic->isIrap() && m_pcPic->getLayerId() == m_smallestLayerId )
+  {
+    // -  When the current picture is an IRAP picture with nuh_layer_id equal to SmallestLayerId, 
+    //    all reference pictures with any value of nuh_layer_id currently in the DPB (if any) are marked 
+    //    as "unused for reference" when at least one of the following conditions is true:
+
+    if ( m_pcPic->getNoClrasOutputFlag() || m_pcPic->getActivatesNewVps() )
+    {
+      // -  The current picture has NoClrasOutputFlag is equal to 1.
+      // -  The current picture activates a new VPS.
+      m_dpb->markAllSubDpbAsUnusedForReference( );
+    }
+  }
+
+  // -  It is a requirement of bitstream conformance that the RPS is restricted as follows:
+  // -  When the current picture is a CRA picture, there shall be no picture in RefPicSetStCurrBefore, RefPicSetStCurrAfter 
+  //    or RefPicSetLtCurr.
+
+  std::vector<TComPic*>** refPicSetsCurr       = m_pcPic->getDecodedRps()->m_refPicSetsCurr;
+
+  if ( m_pcPic->isCra() )
+  {
+    for (Int j = 0; j < 3; j++ )   
+    {    
+      std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+      assert ( cSet->size() == 0 ); 
+    }
+  }
+
+  // -  The constraints specified in clause 8.3.2 on the value of NumPicTotalCurr are replaced with the following:
+  //    -  It is a requirement of bitstream conformance that the following applies to the value of NumPicTotalCurr:
+  Int numPicTotalCurr = m_pcPic->getSlice(0)->getNumPicTotalCurr(); 
+  Int currPicLayerId  = m_pcPic->getLayerId(); 
+  const TComVPS* vps  = m_pcPic->getSlice(0)->getVPS(); 
+
+  if ( ( m_pcPic->isBla() || m_pcPic->isCra() ) && (  (currPicLayerId == 0 ) || ( vps->getNumDirectRefLayers( currPicLayerId ) == 0 ) ) )
+  {   
+    assert( numPicTotalCurr == 0 ); 
+    // -  If the current picture is a BLA or CRA picture and either currPicLayerId is equal to 0 or 
+    //     NumDirectRefLayers[ currPicLayerId ] is equal to 0, the value of NumPicTotalCurr shall be equal to 0.
+  }
+  else
+  {
+    // TBD: check all slices
+    if ( m_pcPic->getSlice(0)->getSliceType() == P_SLICE  ||  m_pcPic->getSlice(0)->getSliceType() == B_SLICE )
+    {
+      // -  Otherwise, when the current picture contains a P or B slice, the value of NumPicTotalCurr shall not be equal to 0.
+      assert( numPicTotalCurr != 0 ); 
+    }
+  }
+}
+
+
+Void TDecTop::xG813DecProcForInterLayerRefPicSet()
+{
+  ////////////////////////////////////////////////////////////////////
+  // G.8.1.3 Decoding process for inter-layer reference picture set //
+  ////////////////////////////////////////////////////////////////////
+
+  // Outputs of this process are updated lists of inter-layer reference pictures RefPicSetInterLayer0 and RefPicSetInterLayer1 
+  // and the variables NumActiveRefLayerPics0 and NumActiveRefLayerPics1.
+
+  TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+  TComSlice* slice       = m_pcPic->getSlice( 0 ); 
+  const TComVPS* vps     =  slice->getVPS(); 
+
+  Int&                   numActiveRefLayerPics0 = decRps->m_numActiveRefLayerPics0;
+  Int&                   numActiveRefLayerPics1 = decRps->m_numActiveRefLayerPics1;
+
+  std::vector<TComPic*>& refPicSetInterLayer0   = decRps->m_refPicSetInterLayer0;
+  std::vector<TComPic*>& refPicSetInterLayer1   = decRps->m_refPicSetInterLayer1; 
+
+  // The variable currLayerId is set equal to nuh_layer_id of the current picture.
+  Int currLayerId = getLayerId(); 
+
+  // The lists RefPicSetInterLayer0 and RefPicSetInterLayer1 are first emptied, NumActiveRefLayerPics0 and NumActiveRefLayerPics1 
+  // are set equal to 0 and the following applies:
+
+  refPicSetInterLayer0.clear(); 
+  refPicSetInterLayer1.clear(); 
+
+  numActiveRefLayerPics0 = 0; 
+  numActiveRefLayerPics1 = 0; 
+
+  Int viewIdCurrLayerId  = vps->getViewId( currLayerId ); 
+  Int viewId0            = vps->getViewId( 0   );
+
+  for( Int i = 0; i < slice->getNumActiveRefLayerPics(); i++ )   
+  {
+    Int viewIdRefPicLayerIdi = vps->getViewId( slice->getRefPicLayerId( i ) ); 
+
+    Bool refPicSet0Flag =
+      ( ( viewIdCurrLayerId <=  viewId0  &&  viewIdCurrLayerId <=  viewIdRefPicLayerIdi )  ||
+      ( viewIdCurrLayerId >=  viewId0  &&  viewIdCurrLayerId >=  viewIdRefPicLayerIdi ) );
+
+    TComPic* picX = m_dpb->getAu(slice->getPOC(), false )->getPic( slice->getRefPicLayerId( i ) );
+    if ( picX != NULL )
+    {
+      // there is a picture picX in the DPB that is in the same access unit as the current picture and has
+      // nuh_layer_id equal to RefPicLayerId[ i ] 
+
+      if ( refPicSet0Flag )
+      {
+        refPicSetInterLayer0.push_back( picX );
+        refPicSetInterLayer0[ numActiveRefLayerPics0++ ]->markAsUsedForLongTermReference();
+      }
+      else
+      {
+        refPicSetInterLayer1.push_back( picX );
+        refPicSetInterLayer1[ numActiveRefLayerPics1++ ]->markAsUsedForLongTermReference();
+      }
+
+      // There shall be no picture that has discardable_flag equal to 1 in RefPicSetInterLayer0 or RefPicSetInterLayer1.
+      assert( ! picX->getSlice(0)->getDiscardableFlag() );
+
+      // If the current picture is a RADL picture, there shall be no entry in RefPicSetInterLayer0 or RefPicSetInterLayer1 
+      // that is a RASL picture.
+      if ( m_pcPic->isRadl() )
+      {
+        assert( ! picX->isRasl() );
+      }
+    }
+    else
+    {
+      if( refPicSet0Flag )
+      {
+        refPicSetInterLayer0.push_back( NULL ); // "no reference picture" (G 1)
+        numActiveRefLayerPics0++;
+      }
+      else
+      {
+        refPicSetInterLayer1.push_back( NULL ); // "no reference picture";
+        numActiveRefLayerPics1++;
+      }
+      // There shall be no entry equal to "no reference picture" in RefPicSetInterLayer0 or RefPicSetInterLayer1.
+      assert( false );
+    }
+  }
+}
+
+
+Void TDecTop::x8331GenDecProcForGenUnavilRefPics()
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // 8.3.3.1  General decoding process for generating unavailable reference pictures ////
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  // This process is invoked once per coded picture when the current picture is a 
+  // BLA picture or is a CRA picture with NoRaslOutputFlag equal to 1.
+
+  assert( m_pcPic->isBla() || (m_pcPic->isCra() && m_pcPic->getNoRaslOutputFlag() ) );
+  TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+
+  std::vector<TComPic*>& refPicSetStFoll      = decRps->m_refPicSetStFoll;
+  std::vector<TComPic*>& refPicSetLtFoll      = decRps->m_refPicSetLtFoll; 
+
+  const std::vector<Int>& pocStFoll             = decRps->m_pocStFoll;
+  const std::vector<Int>& pocLtFoll             = decRps->m_pocLtFoll;
+
+  const Int               numPocStFoll          = decRps->m_numPocStFoll;
+  const Int               numPocLtFoll          = decRps->m_numPocLtFoll;   
+
+  // When this process is invoked, the following applies:
+  for ( Int i = 0 ; i <= numPocStFoll - 1; i++ )
+  {
+    if ( refPicSetStFoll[ i ] == NULL )
+    {
+      //-  For each RefPicSetStFoll[ i ], with i in the range of 0 to NumPocStFoll - 1, inclusive, that is equal 
+      //   to "no reference picture", a picture is generated as specified in clause 8.3.3.2, and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( true );  
+
+      // -  The value of PicOrderCntVal for the generated picture is set equal to PocStFoll[ i ].
+      genPic->getSlice(0)->setPOC( pocStFoll[ i ] );
+
+      //-  The value of PicOutputFlag for the generated picture is set equal to 0.  
+      genPic->setPicOutputFlag( false ); 
+
+      // -  The generated picture is marked as "used for short-term reference".
+      genPic->markAsUsedForShortTermReference();
+
+      // -  RefPicSetStFoll[ i ] is set to be the generated reference picture.
+      refPicSetStFoll[ i ] = genPic;
+
+      // -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id of the current picture.
+      genPic->setLayerId( m_pcPic-> getLayerId() ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+
+  for ( Int i = 0 ; i <= numPocLtFoll - 1; i++ )
+  {
+    if ( refPicSetLtFoll[ i ] == NULL )
+    {
+      //-  For each RefPicSetLtFoll[ i ], with i in the range of 0 to NumPocLtFoll - 1, inclusive, that is equal to 
+      //   "no reference picture", a picture is generated as specified in clause 8.3.3.2, and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( true );  
+
+      //-  The value of PicOrderCntVal for the generated picture is set equal to PocLtFoll[ i ].
+      genPic->getSlice(0)->setPOC( pocStFoll[ i ] );
+
+      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtFoll[ i ] & ( MaxPicOrderCntLsb - 1 ) ).
+      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtFoll[ i ] & ( m_pcPic->getSlice(0)->getSPS()->getMaxPicOrderCntLsb() - 1 ) ) ); 
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.    
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for long-term reference".
+      genPic->markAsUsedForLongTermReference();
+
+      //  -  RefPicSetLtFoll[ i ] is set to be the generated reference picture.
+      refPicSetLtFoll[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id of the current picture.
+      genPic->setLayerId( m_pcPic-> getLayerId() ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+}
+
+
+TComPic* TDecTop::x8332GenOfOneUnavailPic( Bool calledFromCl8331 )
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // 8.3.3.2 Generation of one unavailable picture
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  TComPic* genPic = new TComPic; 
+  genPic->create( *m_pcPic->getSlice(0)->getSPS(), *m_pcPic->getSlice(0)->getPPS(), true ); 
+  genPic->setIsGenerated( true );     
+  genPic->setIsGeneratedCl833( calledFromCl8331 ); 
+  return genPic;
+}
+
+
+Void TDecTop::xF817DecProcForGenUnavRefPicForPicsFrstInDecOrderInLay()
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // F.8.1.7 Decoding process for generating unavailable reference pictures for pictures 
+  //         first in decoding order within a layer
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  //  This process is invoked for a picture with nuh_layer_id equal to layerId, when FirstPicInLayerDecodedFlag[layerId ] is equal to 0.   
+  assert( !m_firstPicInLayerDecodedFlag[ getLayerId() ] );
+
+
+  TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+
+  std::vector<TComPic*>& refPicSetStCurrBefore = decRps->m_refPicSetStCurrBefore; 
+  std::vector<TComPic*>& refPicSetStCurrAfter  = decRps->m_refPicSetStCurrAfter;
+  std::vector<TComPic*>& refPicSetStFoll       = decRps->m_refPicSetStFoll;
+  std::vector<TComPic*>& refPicSetLtCurr       = decRps->m_refPicSetLtCurr; 
+  std::vector<TComPic*>& refPicSetLtFoll       = decRps->m_refPicSetLtFoll; 
+
+
+  const std::vector<Int>& pocStCurrBefore      = decRps->m_pocStCurrBefore;
+  const std::vector<Int>& pocStCurrAfter       = decRps->m_pocStCurrAfter;
+  const std::vector<Int>& pocStFoll            = decRps->m_pocStFoll;
+  const std::vector<Int>& pocLtCurr            = decRps->m_pocLtCurr;
+  const std::vector<Int>& pocLtFoll            = decRps->m_pocLtFoll;
+
+  const Int numPocStCurrBefore                 = decRps->m_numPocStCurrBefore; 
+  const Int numPocStCurrAfter                  = decRps->m_numPocStCurrAfter;
+  const Int numPocStFoll                       = decRps->m_numPocStFoll;
+  const Int numPocLtCurr                       = decRps->m_numPocLtCurr;
+  const Int numPocLtFoll                       = decRps->m_numPocLtFoll;   
+
+  Int nuhLayerId = m_pcPic-> getLayerId(); 
+  for ( Int i = 0 ; i <= numPocStCurrBefore - 1; i++ )
+  {
+    if ( refPicSetStCurrBefore[ i ] == NULL )
+    {
+      //-  For each RefPicSetStCurrBefore[ i ], with i in the range of 0 to NumPocStCurrBefore - 1, inclusive, that is 
+      //  equal to "no reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+
+      //-  The value of PicOrderCntVal for the generated picture is set equal to PocStCurrBefore[ i ].
+      genPic->getSlice(0)->setPOC( pocStCurrBefore[ i ] );
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for short-term reference".
+      genPic->markAsUsedForShortTermReference();
+
+      //  -  RefPicSetStCurrBefore[ i ] is set to be the generated reference picture.
+      refPicSetStCurrBefore[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
+      genPic->setLayerId( nuhLayerId ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+
+  for ( Int i = 0 ; i <= numPocStCurrAfter - 1; i++ )
+  {
+    if ( refPicSetStCurrAfter[ i ] == NULL )
+    {
+      //  -  For each RefPicSetStCurrAfter[ i ], with i in the range of 0 to NumPocStCurrAfter - 1, inclusive, that is equal 
+      //     to "no reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+
+      //  -  The value of PicOrderCntVal for the generated picture is set equal to PocStCurrAfter[ i ].
+      genPic->getSlice(0)->setPOC( pocStCurrAfter[ i ] );
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for short-term reference".
+      genPic->markAsUsedForShortTermReference();
+
+      //  -  RefPicSetStCurrAfter[ i ] is set to be the generated reference picture.
+      refPicSetStCurrAfter[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
+      genPic->setLayerId( nuhLayerId ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+
+    }
+  }
+
+  for ( Int i = 0 ; i <= numPocStFoll - 1; i++ )
+  {
+    if ( refPicSetStFoll[ i ] == NULL )
+    {
+      //  -  For each RefPicSetStFoll[ i ], with i in the range of 0 to NumPocStFoll - 1, inclusive, that is equal to "no 
+      //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+
+      //  -  The value of PicOrderCntVal for the generated picture is set equal to PocStFoll[ i ].
+      genPic->getSlice(0)->setPOC( pocStFoll[ i ] );
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for short-term reference".
+      genPic->markAsUsedForShortTermReference();
+
+      //  -  RefPicSetStFoll[ i ] is set to be the generated reference picture.
+      refPicSetStFoll[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
+      genPic->setLayerId( nuhLayerId ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+
+  Int maxPicOrderCntLsb = m_pcPic->getSlice(0)->getSPS()->getMaxPicOrderCntLsb();  
+  for ( Int i = 0 ; i <= numPocLtCurr - 1; i++ )
+  {
+    if ( refPicSetLtCurr[ i ] == NULL )
+    {
+      //  -  For each RefPicSetLtCurr[ i ], with i in the range of 0 to NumPocLtCurr - 1, inclusive, that is equal to "no 
+      //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+
+      //  -  The value of PicOrderCntVal for the generated picture is set equal to PocLtCurr[ i ].
+      genPic->getSlice(0)->setPOC( pocLtCurr[ i ] );
+
+      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & ( 
+      //     MaxPicOrderCntLsb - 1 ) ).
+      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) ); 
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for long-term reference".
+      genPic->markAsUsedForLongTermReference();
+
+      //  -  RefPicSetLtCurr[ i ] is set to be the generated reference picture.
+      refPicSetLtCurr[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
+      genPic->setLayerId( nuhLayerId ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+
+  for ( Int i = 0 ; i <= numPocLtFoll - 1; i++ )
+  {
+    if ( refPicSetLtFoll[ i ] == NULL )
+    {
+      //  -  For each RefPicSetLtFoll[ i ], with i in the range of 0 to NumPocLtFoll - 1, inclusive, that is equal to "no 
+      //     reference picture", a picture is generated as specified in clause 8.3.3.2 and the following applies:
+      TComPic* genPic = x8332GenOfOneUnavailPic( false );  
+
+      //  -  The value of PicOrderCntVal for the generated picture is set equal to PocLtFoll[ i ].
+      genPic->getSlice(0)->setPOC( pocLtFoll[ i ] );
+
+      //  -  The value of slice_pic_order_cnt_lsb for the generated picture is inferred to be equal to ( PocLtCurr[ i ] & ( 
+      //     MaxPicOrderCntLsb - 1 ) ).
+      genPic->getSlice(0)->setSlicePicOrderCntLsb( ( pocLtCurr[ i ] & ( maxPicOrderCntLsb - 1 ) ) ); 
+
+      //  -  The value of PicOutputFlag for the generated picture is set equal to 0.
+      genPic->setPicOutputFlag( false ); 
+
+      //  -  The generated picture is marked as "used for long-term reference".
+      genPic->markAsUsedForLongTermReference();
+
+      //  -  RefPicSetLtFoll[ i ] is set to be the generated reference picture.
+      refPicSetLtFoll[ i ] = genPic;
+
+      //  -  The value of nuh_layer_id for the generated picture is set equal to nuh_layer_id.
+      genPic->setLayerId( nuhLayerId ); 
+
+      // Insert to DPB
+      m_dpb->addNewPic( genPic ); 
+    }
+  }
+}
+
+Void TDecTop::xF833DecProcForGenUnavRefPics()
+{
+  ///////////////////////////////////////////////////////////////////////////////////////
+  // F.8.3.3 Decoding process for generating unavailable reference picture
+  ///////////////////////////////////////////////////////////////////////////////////////
+
+  x8331GenDecProcForGenUnavilRefPics();
+}
+
+Void TDecTop::xCheckUnavailableRefPics()
+{
+  std::vector<TComPic*>** refPicSetsCurr       = m_pcPic->getDecodedRps()->m_refPicSetsCurr;
+
+  Bool hasGeneratedRefPic = false; 
+  for (Int j = 0; j < 3; j++ )   
+  {    
+    std::vector<TComPic*>* cSet = refPicSetsCurr[j]; 
+    for (Int i = 0 ; i < cSet->size();  i++ )
+    {
+      assert( (*cSet)[i] != NULL );
+      if ((*cSet)[i]->getIsGenerated() )
+      {
+        hasGeneratedRefPic = true; 
+      }
+    }
+  }
+  m_pcPic->setHasGeneratedRefPics( hasGeneratedRefPic ); 
+}
+
 #endif
 
